//***********************************************************************
// Push\ʒu}bv, JnBOX, JnMAN)
//***********************************************************************
void LS_Push(int push[], int box2, int man2)
{
	int  box1, qtop=0, qend=0;
	int  vect1, vect2, bit1, bit2, b1, b2;
	int  qbox[MaxArea*4];
	int  qbit[MaxArea*4];

	Wall[box2] = BOX;
	Paint2(Wall, man2);
	Wall[box2] = 0;
	bit2 = 0;
	for (vect2=0,b2=1; vect2<4; vect2++,b2<<=1)
		if (PMAP2[box2 + Diff[vect2]] == P_ID2) bit2 |= b2;
	push[box2] = bit2;
	qbox[qend] = box2;
	qbit[qend] = bit2;
	qend++;

	while (qtop < qend) {
		box1 = qbox[qtop];
		bit1 = qbit[qtop];
		for (vect1=0,b1=1; vect1<4; vect1++,b1<<=1) {
			if (!(bit1 & b1)) continue;
			box2 = box1 - Diff[vect1];
			man2 = box1;
			// box2ʒuǂ܂͋L^
			if (Wall[box2] || (push[box2] & b1)) continue;

			Wall[box2] = BOX;
			Paint2(Wall, man2);
			Wall[box2] = 0;
			bit2 = 0;
			for (vect2=0,b2=1; vect2<4; vect2++,b2<<=1)
				if (PMAP2[box2 + Diff[vect2]] == P_ID2) bit2 |= b2;
			push[box2] |= bit2;
			qbox[qend] = box2;
			qbit[qend] = bit2;
			qend++;
		}
		qtop++;
	}
}
//*****************************************************************************
// zu֎~}bv(Ȃʒu)
//*****************************************************************************
void LS_NoPush(void)
{
	int  i, j, bit=1;
	int  area[MaxArea], push[MaxArea];

	// ̈𒲂ׂ
	for (i=0; i<Area; i++)
		area[i] = Bits[i] = 0;
	for (i=0; i<Area; i++) {
		if (Bmap[i] != BOX) continue;
		for (j=0; j<Area; j++) push[j] = 0;
		LS_Push(push, i, Mpos);
		for (j = 0; j < Area; j++) {
			if (push[j]) {
				area[j] = 1;
				Bits[j] |= bit;	// }gbNX}bv
			}
		}
		bit <<= 1;
	}

	// Ȃ̈Nmap[]
	for (i=0; i<Area; i++)
		if (!Wall[i] && !area[i]) Nmap[i] = 1;
}
//*****************************************************************************
// zu֎~}bv(gl)
//*****************************************************************************
void LS_Tunnel(void)
{
	int  y, x, i, j, flag;

	// zu֎~}bv
	for (i=0; i<Area; i++) Nmap[i] = 0;

	// gl
	for (y=1; y<Height-1; y++) {
		flag = 0;
		for (x=1; x<Width; x++) {
			i = y * Width + x;
			if (!Wall[i] && Wall[i-Width] && Wall[i+Width]) {
				if (flag) Nmap[i-1] = Nmap[i] = 1;
				flag = 1;
			} else {
				if (flag) {
					for (j=i-1; Nmap[j]; j--)
						if (Bmap[j]) Nmap[j] = 0;	// BOXʒu
					if (!Wall[i+1]) Nmap[i-1] = 0;	// E[
					if (!Wall[j-1]) Nmap[j+1] = 0;	// [
				}
				flag = 0;
			}
		}
	}

	// cgl
	for (x=1; x<Width-1; x++) {
		flag = 0;
		for (y=1; y<Height; y++) {
			i = y * Width + x;
			if (!Wall[i] && Wall[i-1] && Wall[i+1]) {
				if (flag) Nmap[i-Width] = Nmap[i] = 1;
				flag = 1;
			} else {
				if (flag) {
					for (j=i-Width; Nmap[j]; j-=Width)
						if (Bmap[j]) Nmap[j] = 0;			// BOXʒu
					if (!Wall[i+Width]) Nmap[i-Width] = 0;	// [
					if (!Wall[j-Width]) Nmap[j+Width] = 0;	// [
				}
				flag = 0;
			}
		}
	}
}
//*****************************************************************************
// _~[p[c
//*****************************************************************************
int LS_Dummy(void)
{
	int  i, cnt, vect, flag;

	// BOXĉȂBOXGOALWALL
	for (i=0; i<Area; i++)
		if (!Wall[i] && (LevelMap[i] & BOX)) Wall[i] = BOX;
	do {
		flag = 0;
		Paint1(Wall, Mpos);
		for (i=0; i<Area; i++) {
			if (Wall[i] != BOX) continue;
			for (vect=0; vect<4; vect++) {
				// BOX
				if (Wall[i-Diff[vect]]==0 && PMAP1[i+Diff[vect]]==P_ID1) {
					Wall[i] = 0;
					flag = 1;
					break;
				}
			}
		}
	} while (flag);
	for (i=0; i<Area; i++) {
		if (Wall[i] == BOX) {
			if (!(LevelMap[i] & GOAL)) return 3;	//3: qɈُ
			Wall[i] = WALL;
		}
	}

	// ԂBOXĈȂBOXGOALWALL
	for (i=0; i<Area; i++)
		if (!Wall[i] && (LevelMap[i] & GOAL)) Wall[i] = GOAL;
	do {
		flag = 0;
		for (i=0; i<Area; i++) {
			if (Wall[i] != GOAL) continue;
			for (vect=0; vect<4; vect++) {
				// BOX
				if (Wall[i+Diff[vect]]==0 && Wall[i+Diff[vect]+Diff[vect]]==0) {
					Wall[i] = 0;
					flag = 1;
					break;
				}
			}
		}
	} while (flag);
	for (i=0; i<Area; i++) {
		if (Wall[i] == GOAL) {
			if (!(LevelMap[i] & BOX)) return 3;	// 3:qɈُ
			Wall[i] = WALL;
		}
	}

	// qɂ̎Oʉ݂ǂ
	for (i=0; i<Area; i++) {
		if (Wall[i]) continue;
		if (LevelMap[i] & BOX ) Wall[i] += BOX;
		if (LevelMap[i] & GOAL) Wall[i] += GOAL;
	}
	Wall[Mpos] += MAN;
	do {
		flag = 0;
		for (i=0; i<Area; i++) {
			if (Wall[i]) continue;
			cnt = 0;
			for (vect=0; vect<4; vect++)
				if (Wall[i+Diff[vect]] == WALL) cnt++;
			if (cnt >= 3) {
				Wall[i] = WALL;
				flag = 1;
			}
		}
	} while (flag);
	for (i=0; i<Area; i++) {
		if (Wall[i] != WALL) Wall[i] = 0;
	}

	return 0;	// I
}
//***********************************************************************
// qɂJĂȂ?
//***********************************************************************
BOOL LS_IsOpen(int soko[], int paint[], int pos0)
{
	int  i, y, x, pos1, vect, qtop=0, qend=0;
	int  queue[MaxArea];

	for (i=0; i<Area; i++)
		paint[i] = 0;

	paint[pos0] = 1;
	queue[qend++] = pos0;
	while (qtop < qend) {
		pos0 = queue[qtop++];
		y = pos0 / Width;
		x = pos0 % Width;
		if (y==0 || y==(Height-1)) return TRUE;	// JĂ(ُ)
		if (x==0 || x==(Width -1)) return TRUE;	// @V
		for (vect=0; vect<4; vect++) {
			pos1 = pos0 + Diff[vect];
			if (!soko[pos1] && !paint[pos1]) {
				paint[pos1] = 1;
				queue[qend++] = pos1;
			}
		}
	}
	return FALSE;	// JĂȂ()
}
//*****************************************************************************
// Gg[	ret = 0: 1:Over 2:ُ
//*****************************************************************************
int  LevelSelector(void)
{
	HANDLE h;
	DWORD bytes;
	char filename[MAX_PATH];
	char *ptr, *top, *end;
	int  len1, len2, y, x, i, gcnt, mcnt;
	int  paint[MaxArea];

	// 
	Width = Height = Boxes = Bcnt = 0;
	Moves = Tout = 0;
	UseSec = C_use = Q_use = 0;
	*Trace = '\0';
	for (i=0; i<MaxArea; i++) LevelMap[i] = 0;

	// ReadFile -> FileBuff
	wsprintf(filename, "%s%04d.txt", LevelFolder, LevelNumber);
	h = CreateFile(filename, GENERIC_READ, FILE_SHARE_READ, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
	if (h == INVALID_HANDLE_VALUE) return FALSE;
	ReadFile(h, FileBuff, BuffSize, &bytes, NULL);
	CloseHandle(h);
	*(FileBuff + bytes) = '\0';

	// Width, Height, Area
	top = FileBuff;
	for (;;) {
		end = strchr(top, '\n');
		if (!end) break;

		// qɃf[^?
		*end = '\0';
		len1 = (int)strlen(top);
		len2 = (int)strspn(top, " .$*@+#");
		*end = '\n';
		if (len1 != len2) break;

		// Width, Height
		Height++;
		if (len1 > Width) Width = len1;

		top = end + 1;
	}
	Area = Width * Height;
	if (Area > MaxArea) {
		// Boxes𒲂ׂĂI
		for (ptr=FileBuff; *ptr; ptr++)
			if (*ptr=='$' || *ptr=='*') Boxes++;
		return 1;	// 1:SizeOver
	}

	// LevelMap[], Boxes, Mpos
	gcnt = mcnt = 0;
	ptr = FileBuff;
	for (y=0; y<Height; y++) {
		for (x=0; x<Width; x++,ptr++) {
			if (*ptr == '\n') break;
			i = Width * y + x;
			if (*ptr=='#') LevelMap[i] |= WALL;
			if (*ptr=='$' || *ptr=='*') { LevelMap[i] |= BOX; Boxes++; }
			if (*ptr=='@' || *ptr=='+') { LevelMap[i] |= MAN; mcnt++; Mpos = i; }
			if (*ptr=='.' || *ptr=='*' || *ptr=='+') { LevelMap[i] |= GOAL; gcnt++; }
		}
		ptr++;
	}
	if (Boxes == 0) return 3;		// 3:qɈُ
	if (gcnt != Boxes) return 3;	// 3:qɈُ
	if (mcnt != 1) return 3;		// 3:qɈُ

	// Diff[]
	Diff[0] = -Width;
	Diff[1] = -1;
	Diff[2] =  Width;
	Diff[3] =  1;

	// qɂJĂȂ?
	for (i=0; i<Area; i++)
		Wall[i] = LevelMap[i] & WALL;
	if (LS_IsOpen(Wall, paint, Mpos)) return 3;	// 3:qɈُ

	//  O(OUTSIDE)
	for (i=0; i<Area; i++) {
		if (paint[i] == 0) {
			if (LevelMap[i]==BOX || LevelMap[i]==GOAL) return 3;	// 3:qɈُ
			if (LevelMap[i] == FLOOR) {
				LevelMap[i] = OUTSIDE;	// O
				Wall[i] = WALL;
			}
		}
	}

	// _~[p[c
	if (LS_Dummy()) return 4;	// 4:s\

	// Bmap[], Gmap[], Bcnt
	Bcnt =0;
	for (i=0; i<Area; i++) {
		Bmap[i] = Gmap[i] = 0;
		if (Wall[i]) continue;
		if (LevelMap[i] & BOX) { Bmap[i]=BOX; Bcnt++; } 
		if (LevelMap[i] & GOAL) Gmap[i] = GOAL;
	}
	if (Bcnt > MaxBoxes) return 2;	// 2:BoxesOver

	// zu֎~}bv(gl)
	LS_Tunnel();

	// zu֎~}bv(Ȃʒu)
	LS_NoPush();

	// 0: 1:SizeOver 2:BoxesOver 3:qɈُ 4:s\
	return 0;
}
