//*****************************************************************************
// qɔԍŒZT Ver1.2			by takaken	2021.03.06
//	(R\[ŃC^[tF[X / Tv)
//*****************************************************************************
// CV݊Ή(1)
#define _CRT_SECURE_NO_WARNINGS

// Cinclude
#include <stdio.h>
#include <climits>
#include <time.h>
#include <windows.h>

// CV݊Ή(2)
#ifndef strcpy_s
#define strcat_s(a,b,c)		strcat(a,c)
#define strcpy_s(a,b,c)		strcpy(a,c)
#define strncpy_s(a,b,c,d)	strncpy(a,c,d)
#endif

// Tu\[Xinclude
#include "./Header.c"
#include "./Loader.c"
#include "./Selector.c"
#include "./Solver.c"

//*****************************************************************************
// TraceViewer
//*****************************************************************************
void TraceViewer(void)
{
	int  i, y, x, vect, push, man;
	int  moves, soko[MaxArea];
	char *p;

	for (i=0; i<Area; i++)
		soko[i] = LevelMap[i];
	man = Mpos;

	moves = 0;
	for (p=Trace; ; p++) {
		// Ֆʕ\
		system("cls");
		printf("%s%3d[%2d*%2d(%2d)] %3d/%3dmoves\n", LevelName, LevelNumber, Width, Height, Boxes, moves++, Moves);
		for (y=0; y<Height; y++) {
			for (x=0; x<Width; x++) {
				i = y * Width + x;
				switch (soko[i]) {
				case FLOOR:   printf("@"); break;
				case GOAL:    printf("E"); break;
				case BOX:     printf(""); break;
				case BOXGOAL: printf(""); break;
				case MAN:     printf(""); break;
				case MANGOAL: printf(""); break;
				case WALL:    printf(""); break;
				case OUTSIDE: printf("^"); break;
				}
			}
			printf("\n");
		}
		Sleep(300);

		// g[Xf[^ǂݎĔՖʍXV
		if (*p == '\0') break;
		switch (*p) {
		case 'u': vect=0; push=0; break;
		case 'l': vect=1; push=0; break;
		case 'd': vect=2; push=0; break;
		case 'r': vect=3; push=0; break;
		case 'U': vect=0; push=1; break;
		case 'L': vect=1; push=1; break;
		case 'D': vect=2; push=1; break;
		case 'R': vect=3; push=1; break;
		}
		soko[man] -= MAN;
		man += Diff[vect];	// Move
		soko[man] += MAN;
		if (push) {			// Push
			soko[man] -= BOX;
			soko[man+Diff[vect]] += BOX;
		}
	}
	Sleep(600);
}
//*****************************************************************************
// eLXgf[^@Tv
//*****************************************************************************
char TextData[] =
// BeginEnd̃}bv(Œ1Push邱)
"#########\n"
"#       #\n"
"#  *  @ #\n"
"#########\n"
"\n"
// Ver1.0ŊԈo}bv
"#########\n"
"#   #   #\n"
"#  $ @# #\n"
"#  .### #\n"
"#     # #\n"
"#     # #\n"
"#       #\n"
"#########\n"
"\n"
// Ver1.1ŉȂ{̃}bv
"#####     #####\n"
"#@  #######   #\n"
"#      $ $ $  #\n"
"### $      ####\n"
"  #        .#\n"
"  #        .#\n"
"  #        .#\n"
"  #        .#\n"
"  #         #\n"
"###         ###\n"
"#             #\n"
"#   #######   #\n"
"#####     #####\n"
;

//*****************************************************************************
// Gg[|Cg
//*****************************************************************************
int  main(void)
{
	int  count, solve, retc=0;
	SYSTEMTIME st;

	// xZbg荞
	retc = LevelLoader(1, TextData);							// eLXg`()
//	retc = LevelLoader(2, "C:\\sokoban\\file\\takaken.txt");	// t@C`()
//	retc = LevelLoader(3, "C:\\sokoban\\folder\\perfect");		// tH_`()
	if (!retc) {
		printf("xZbg̎荞݂Ɏs܂B\n");
		return 0;
	}

	// ob`s
	count = solve = 0;
	printf("# %s\n", Title);
	printf("# LevelSetName: %s (%d levels)\n", LevelName, LevelVolume);
	printf("# MaxArea:%4d MaxBoxes:%2d", MaxArea, MaxBoxes);
	GetLocalTime(&st);
	printf("  [%4d/%02d/%02d %02d:%02d Start]\n", st.wYear, st.wMonth, st.wDay, st.wHour, st.wMinute);
	printf(" No.  W  H  B     Time     Cells   Queue     Result\n");
	printf("------------------------------------------------------\n");
	for (LevelNumber=1; LevelNumber<=LevelMaxNum; LevelNumber++) {
		// xǂݎ
		retc = LevelSelector();
		if (retc==1 || retc==2 || retc==3) continue;	// ΏۊO

		count++;
		printf("%4d[%2d*%2d(%2d)] ", LevelNumber, Width, Height, Boxes);

		// \o[s
		if (retc == 0) {
			retc = Solver();
		}
		printf("%4dsec%9d%8d ", UseSec, C_use, Q_use);

		// ʕ\
		if (retc == 8) {	// Solved
			solve++;
			printf("%5dmoves%s\n", Moves, Tout? " TraceOver": "");
			//printf("%s\n", Trace);	// g[X\
			//TraceViewer();			// g[XČ
		} else {
			switch (retc) {
			case 4:	printf(" Impossible\n"); break;
			case 5:	printf(" Failed(C)\n"); break;
			case 6:	printf(" Failed(Q)\n"); break;
			case 7:	printf(" Canceled\n"); break;
			}
		}
	}
	printf("------------------------------------------------------\n");
	GetLocalTime(&st);
	printf("# TryCnt:%4d levels       [%4d/%02d/%02d %02d:%02d Finish]\n", count, st.wYear, st.wMonth, st.wDay, st.wHour, st.wMinute);
	printf("# Solved:%4d levels\n", solve);

	return 0;
}
