//*****************************************************************************
// g[Xf[^쐬
//*****************************************************************************
// man0man1֍ŒZ[gŕ
void SV_TraceWalk(int man1, int man0)
{
	int  vect, pos1, pos2, qtop=0, qend=0, num=1;
	int  step[MaxArea], queue[MaxArea];

	if (man1 == man0) return;

	// Xebv}bv
	for (pos1=0; pos1<Area; pos1++)
		step[pos1] = 0;

	// ړInˏɃXebv}bvL^
	step[man1] = num;	// ړIn
	queue[qend++] = man1;
	while (qtop < qend) {
		pos1 = queue[qtop++];
		num = step[pos1] + 1;
		for (vect=0; vect<4; vect++) {
			pos2 = pos1 + Diff[vect];
			if (pos2 == man0) break;	// on
			if (!step[pos2] && !Map[pos2]) {
				step[pos2] = num;
				queue[qend++] = pos2;
			}
		}
		if (vect < 4) break;
	}

	// onړIn܂ł̍ŒZ[gL^
	for (num--; num>0; num--) {
		for (vect=0; vect<4; vect++) {
			pos1 = man0 + Diff[vect];
			if (step[pos1] == num) break;
		}
		if (strlen(Trace) < MaxTrace) {
			strcat_s(Trace, MaxTrace, Tchr[vect]);	// TraceL^
		} else {
			Tout = 1;	// TraceOver
		}
		man0 = pos1;
	}
}
// ǖʂւ̓Č
void SV_TraceSub(Cell *ptr2, Cell *ptr1)
{
	int  i, n, diff, vect, tmp[MaxArea];
	int  box1, box2, man2;

	// ǖʂ
	for (i=0; i<Area; i++)
		tmp[i] = Wall[i];
	for (n=0; n<Bcnt; n++) {
		tmp[ptr2->box[n]] = BOX;
	}

	// ړOBOXƈړBOẌʒu𒲂ׂ
	box1 = box2 = 0;
	for (i=0; i<Area; i++) {
		if (Map[i]==BOX && tmp[i]==0) box1 = i;
		if (tmp[i]==BOX && Map[i]==0) box2 = i;
		if (box1 && box2) break;
	}

	// ړvect߂
	diff = box1 - Man;
	for (vect=0; vect<4; vect++)
		if (Diff[vect] == diff) break;

	// box1box2܂Ő^
	Map[box1] = 0;
	do {
		box1 += Diff[vect];
		if (strlen(Trace) < MaxTrace) {
			strcat_s(Trace, MaxTrace, Tchr[vect + 4]);	// TraceL^
		} else {
			Tout = 1;	// TraceOver
		}
	} while (box1 != box2);
	Map[box2] = BOX;
	Man = box2 - Diff[vect];

	// Manman2֍ŒZŕ
	man2 = ptr2->man;
	SV_TraceWalk(man2, Man);
	Man = man2;
}
// g[Xf[^쐬
void SV_Trace(void)
{
	int  i;
	Cell *ptr1, *ptr2;

	// Jn}bv
	for (i=0; i<Area; i++)
		Map[i] = Wall[i] + Bmap[i];
	Man = Mpos;

	// Man  FindPtr->man ܂ŕ
	SV_TraceWalk(FindPtr->man, Man);
	Man = FindPtr->man;

	// ptreptr֏o^(^)ptr܂ŒH
	ptr1 = FindPtr;
	while (ptr1->prev) {
		ptr2 = ptr1->prev;
		SV_TraceSub(ptr2, ptr1);
		ptr1 = ptr2;
	}
}
//*****************************************************************************
// }gbNX
//*****************************************************************************
int  SV_MatlixSub(int table[], int y, int down)
{
	int  bitmap, bit;

	if (y == Bcnt) {
		return 1;
	} else {
		bitmap = table[y] & ~down;
		while (bitmap) {
			bit = -bitmap & bitmap;
			bitmap ^= bit;
			if (SV_MatlixSub(table, y + 1, down | bit)) return 1;
		}
	}
	return 0;
}
int  SV_Matlix(void)
{
	int  n;
	int  table[MaxBoxes];

	for (n = 0; n < Bcnt; n++) {
		table[n] = Bits[Box[n]];
	}
	return SV_MatlixSub(table, 0, 0);
}
//*****************************************************************************
// Queue o
//*****************************************************************************
// Queuek(oʒuꍇ)
int  SV_CompSub(int i)
{
	int  top, end;

	// Qnot܂
	end = 0;
	for (top=0; top<Qnot; top++) {
		if (!Queue[i][top]) continue;
		if (top != end)
			Queue[i][end] = Queue[i][top];
		end++;
	}
	Qnot = end;

	// Qtop܂
	for ( ; top<Qtop; top++) {
		if (!Queue[i][top]) continue;
		if (top != end)
			Queue[i][end] = Queue[i][top];
		end++;
	}
	Qtop = end;

	// c
	for ( ; top<QH_SIZE; top++) {
		if (!Queue[i][top]) continue;
		if (top != end)
			Queue[i][end] = Queue[i][top];
		end++;
	}
	Qend[i] = end;

	Q_use = end;	// 󋵔c(őƂ͌Ȃ)

	return (QH_SIZE - end);	// k
}
// Queuek
int  SV_Compress(int i)
{
	int  top, end;

	// ̈ʒu͎oʒu?
	if (i == (MinMove % QW_SIZE))
		return SV_CompSub(i);

	end = 0;
	for (top=0; top<QH_SIZE; top++) {
		if (!Queue[i][top]) continue;
		if (top != end)
			Queue[i][end] = Queue[i][top];
		end++;
	}
	Qend[i] = end;

	Q_use = end;	// 󋵔c(őƂ͌Ȃ)

	return (QH_SIZE - end);	// k
}

// VKo^
BOOL SV_Write(Cell *wptr, int move)
{
	int  i;

	// Queueʒu
	i = move % QW_SIZE;

	// QueueFullȂ爳k
	if (Qend[i]==QH_SIZE && !SV_Compress(i)) return FALSE;	// Qfull

	// Queueo^
	Queue[i][Qend[i]++] = wptr;
	if (Qend[i] > Q_use) Q_use = Qend[i];	// 󋵔c
	QueCnt++;

	return TRUE;
}
// XVo^
BOOL SV_Update(Cell *wptr, int move)
{
	int  i, j;

	// Queue폜
	i = wptr->move % QW_SIZE;
	for (j=0; j<Qend[i]; j++)
		if (Queue[i][j] == wptr) break;
	Queue[i][j] = NULL;
	QueCnt--;

	// Queueo^
	return SV_Write(wptr, move);
}
// o
Cell *SV_Read(void)
{
	int  i;
	Cell *rptr;

	if (!QueCnt) return NULL;	// Que

	for (;;) {
		i = MinMove % QW_SIZE;	// Queue̎ʒu
		while (Qtop < Qend[i]) {
			rptr = Queue[i][Qtop++];
			if (!rptr) continue;
			Queue[i][Qtop-1] = NULL;	// oꏊNULL
			if (rptr->move == MinMove) {
				// o
				QueCnt--;
				return rptr;	// ʂԂ
			} else {
				// xꕪ
				Queue[i][Qnot++] = rptr;
			}
		}
		Qend[i] = Qnot;
		MinMove++;
		if (FindPtr && (MinMove+1)>=FindMove) break;	// ȏ͕sv
		Qnot = Qtop = 0;
	}
	return NULL;	// ȏ͕sv
}
//*****************************************************************************
// i[AhX
//*****************************************************************************
Cell *SV_CellsPtr(int man)
{
	Cell *wptr;
	unsigned int  hash, hash1, hash2, hash3;
	int  n, box;

	// hashl
	hash1 = hash2 = hash3 = man << 3;
	for (n=0; n<Bcnt; n++) {
		box = Box[n];
		hash1 += box;
		hash2 ^= box;
		hash3 *= box;
	}
	if (hash2 == 0) hash2 = hash1;
	hash = (hash1 * hash2 + hash3);
	hash %= CE_FULL;

	// i[Ԓn(wptr)
	for (;;) {
		wptr = &Cells[hash];
		if (wptr->man == 0) break;
		if (wptr->man == man) {
			for (n=0; n<Bcnt; n++)
				if (Map[wptr->box[n]] != BOX) break;
			if (n==Bcnt && wptr->prev) return wptr;		// ^
		}
		hash = (hash + 1) % CE_FULL;	// ănbV
	}

	return wptr;
}
//*****************************************************************************
// man0man1ւ̍ŒZ߂
//*****************************************************************************
int  SV_Steps(int man1, int man0)
{
	int  vect, pos1, pos2, qtop=0, qend=0, move=1;
	int  queue[MaxArea];

	if (man1 == man0) return 0;

	// on_
	Map[man0] = move;
	queue[qend++] = man0;

	// ˏɕL^
	while (qtop < qend) {
		pos1 = queue[qtop++];
		move = Map[pos1] + 1;
		for (vect=0; vect<4; vect++) {
			pos2 = pos1 + Diff[vect];
			if (pos2 == man1) break;	// Bn_
			if (!Map[pos2]) {
				Map[pos2] = move;
				queue[qend++] = pos2;
			}
		}
		if (vect < 4) break;
	}

	// 
	while (qend) {
		Map[queue[--qend]] = 0;
	}

	return (move - 1);
}
//*****************************************************************************
// gl̔zu֎~ʒulPull̈ړ߂
//*****************************************************************************
int  SV_PullBox(int box1, int man1)
{
	int  move, diff, man2;

	move = 1;
	diff = box1 - man1;
	man2 = man1 - diff;
	while (Nmap[man1] && !Map[man2]) {	// gl
		man1 -= diff;
		man2 -= diff;
		move++;
	}
	if (Map[man2]) return 0;	// ǂɂs~܂

	return move;
}
//*****************************************************************************
// tT
//*****************************************************************************
BOOL SV_Seartch(void)
{
	int  n, i, vect, box1, box2, man0, man1, man2;
	int  success, diff, move1, move2, matlix;
	Cell *rptr, *wptr;

	// eǖʂo
	rptr = SV_Read();

	// L[܂͂ȏsv
	if (rptr == NULL)
		return FindPtr? 8: 4;	// 8:Solved 4:Impossible

	// }bv쐬
	success = 0;
	for (n=0; n<Bcnt; n++) {
		box1 = Box[n] = rptr->box[n];
		Map[box1] = BOX;
		if (Bmap[box1]) success++;
	}
	man0 = rptr->man;

	// MANړ͈
	Paint1(Map, man0);

	// Jn^(߂)ɓB
	if (success==Bcnt && PMAP1[Mpos]==P_ID1) {
		move1 = MinMove + SV_Steps(Mpos, man0);
		// _ł̍ŒZȂo^
		if (FindMove==0 || FindMove>move1) {
			FindPtr = rptr;
			FindMove = move1;
		}
		// BOX
		for (n=0; n<Bcnt; n++)
			Map[Box[n]] = 0;
		return 0;	// 0:Tp(܂ŒZƂ͌Ȃ)
	}

	// Vǖʐ
	for (n=0; n<Bcnt; n++) {
		box1 = Box[n];
		for (vect=0; vect<4; vect++) {
			// box1͈邩?
			man1 = box1 + Diff[vect];
			if (PMAP1[man1] != P_ID1) continue;
			man2 = man1 + Diff[vect];
			if (Map[man2]) continue;
			move1 = SV_PullBox(box1, man1);
			if (move1 == 0) continue;	// Ȃ

			// Vǖʂ̕ = ݂̕ +  + 
			move2 = MinMove + SV_Steps(man1, man0) + move1;
			if (FindMove==0 || FindMove>move2) {
				// Vǖʍ쐬
				diff = box1 - man1;
				box2 = box1 - diff * move1;
				man2 = box2 - diff;
				Map[box1] = 0;
				Map[box2] = BOX;
				Box[n] = box2;

				// }gbNX
				if (Bits[box1]==Bits[box2] || Bcnt>31) {
					matlix = 1;
				} else {
					matlix = SV_Matlix();
				}

				// Vǖʓo^
				if (matlix) {
					wptr = SV_CellsPtr(man2);	// qǖʓo^ʒu
					if (wptr->man == 0) {
						// VKo^
						if (C_use == CE_SIZE) return 5;			// 5:Failed(C)
						if (!SV_Write(wptr, move2)) return 6;	// 6:Failed(Q)
						C_use++;
						wptr->man = man2;
						for (i = 0; i < Bcnt; i++)
							wptr->box[i] = Box[i];
						wptr->move = move2;
						wptr->prev = rptr;
					}
					else if (move2 < wptr->move) {
						// XVo^
						if (!SV_Update(wptr, move2)) return 6;	// 6:Failed(Q)
						wptr->move = move2;
						wptr->prev = rptr;
					}
				}

				// ߂
				Map[box1] = BOX;
				Map[box2] = 0;
				Box[n] = box1;
			}
		}
	}

	// BOX
	for (n=0; n<Bcnt; n++)
		Map[Box[n]] = 0;

	return 0;	// Tp
}
//*****************************************************************************
// Gg[
//*****************************************************************************
int  Solver(void)
{
	int  i, n, vect, diff, move, box1, man1, box2, man2, success, retc;
	Cell *rptr, *wptr;
	clock_t start_t;

	// ԏ
	start_t = clock();
	UseSec = 0;

	// Cellsn
	for (i=0; i<CE_FULL; i++)
		Cells[i].man = 0;
	for (i=0; i<QW_SIZE; i++)
		Qend[i] = 0;
	Qtop = Qnot = QueCnt = MinMove = 0;

	// ʏ
	C_use = Q_use = 0;
	FindMove = Moves = 0;
	FindPtr = NULL;
	*Trace = '\0';

	// }bv쐬
	success = n = 0;
	for (i=0; i<Area; i++) {
		Map[i] = Wall[i];
		if (Gmap[i]) {
			Map[i] = BOX;
			Box[n++] = i;
			if (Bmap[i]) success++;
		}
	}
	if (!BeginEnd && success==Bcnt) return 8;	// 8:Solved

	// Jno^
	for (n=0; n<Bcnt; n++) {
		box1 = Box[n];
		for (vect=0; vect<4; vect++) {
			man1 = box1 + Diff[vect];
			if (Map[man1]) continue;
			man2 = man1 + Diff[vect];
			if (Map[man2]) continue;
			move = SV_PullBox(box1, man1);
			if (move == 0) continue;

			// ^o^
			rptr = SV_CellsPtr(man1);
			for (i=0; i<Bcnt; i++)
				rptr->box[i] = Box[i];
			rptr->man = man1;
			rptr->move = 0;
			rptr->prev = NULL;

			// ړ1^o^
			diff = box1 - man1;
			box2 = box1 - diff * move;
			man2 = box2 - diff;
			Map[box1] = 0;
			Map[box2] = BOX;
			Box[n] = box2;

			// o^
			wptr = SV_CellsPtr(man2);
			for (i=0; i<Bcnt; i++)
				wptr->box[i] = Box[i];
			wptr->man = man2;
			wptr->move = move;
			wptr->prev = rptr;
			SV_Write(wptr, move);

			// ߂
			Map[box1] = BOX;
			Map[box2] = 0;
			Box[n] = box1;
		}
	}

	// BOX
	for (n=0; n<Bcnt; n++)
		Map[Box[n]] = 0;

	// tT
	do {
		retc = SV_Seartch();
		UseSec = (clock() - start_t) / CLOCKS_PER_SEC;	// oߎ
		if (CANCEL) retc = 7;	// 7:Cencel
	} while (retc == 0);

	// g[Xf[^쐬
	if (retc == 8) {	// Solved
		SV_Trace();
		Moves = FindMove;
	}

	// 4:Impossible 5:Fialed(C) 6:Fialed(Q) 7:Cancel 8:Solved
	return retc;
}
